.386
.MODEL FLAT,STDCALL
option casemap:none

include	\masm32\include\windows.inc
include	\masm32\include\user32.inc
include	\masm32\include\kernel32.inc
include \masm32\include\urlmon.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\urlmon.lib
includelib \masm32\lib\masm32.lib

include \masm32\macros\macros.asm

$ptr MACRO proc
	lea eax, proc
	EXITM <eax>
ENDM

.CONST
INET_E_DOWNLOAD_FAILURE equ 800C0008h
.DATA?
IBINDSTATUSCALLBACK		STRUCT
	QueryInterface      DWORD ?
	AddRef              DWORD ?
	Release             DWORD ?
	OnStartBinding      DWORD ?
	GetPriority         DWORD ?
	OnLowResource       DWORD ?
	OnProgress          DWORD ?
	OnStopBinding       DWORD ?
	GetBindInfo         DWORD ?
	OnDataAvailable     DWORD ?
	OnObjectAvailable   DWORD ?
IBINDSTATUSCALLBACK		ENDS
sIBindStatusCallback	IBINDSTATUSCALLBACK <?>
hInstance 				DWORD ?
.DATA
.CODE
AddReleaseProc PROC
	xor eax, eax
	ret
AddReleaseProc ENDP

QueryInterfaceProc PROC riid:DWORD, ppv:DWORD
	mov eax, E_NOINTERFACE
	ret
QueryInterfaceProc ENDP

ObjectAvailableProc PROC riid:DWORD, punk:DWORD
	xor eax, eax
	ret
ObjectAvailableProc ENDP

OnDataAvailableProc PROC grfBSCF:DWORD, dwSize:DWORD,pfmtetc:DWORD,pstgmed:DWORD
	xor eax, eax
	ret
OnDataAvailableProc ENDP

OnProgressProc PROC ulProgress:DWORD,ulProgressMax:DWORD,ulStatusCode:DWORD,szStatusText:DWORD
	xor eax, eax
	ret
OnProgressProc ENDP

OnStopBindingProc PROC hrResult:DWORD, szError:DWORD
	xor eax, eax
	ret
OnStopBindingProc ENDP

GetBindInfoProc PROC pgrfBINDF:DWORD, pbindinfo:DWORD
	xor eax, eax
	ret
GetBindInfoProc ENDP

OnLowResourceProc PROC dwReserved:DWORD
	xor eax, eax
	ret
OnLowResourceProc ENDP

GetPriorityProc PROC pnPriority:DWORD
	xor eax, eax
	ret
GetPriorityProc ENDP

OnStartBindingProc PROC grfBSCOption:DWORD, pbinding:DWORD
	xor eax, eax
	ret
OnStartBindingProc ENDP

WinMain PROC STDCALL hInst,hInstPrev,szCmdLine,iCmdShow
push hInst
pop hInstance
mov sIBindStatusCallback.OnStartBinding, $ptr(OnStartBindingProc)
mov sIBindStatusCallback.GetPriority, $ptr(GetPriorityProc)
mov sIBindStatusCallback.OnLowResource, $ptr(OnLowResourceProc)
mov sIBindStatusCallback.OnStopBinding, $ptr(OnStopBindingProc)
mov sIBindStatusCallback.GetBindInfo, $ptr(GetBindInfoProc)
mov sIBindStatusCallback.OnDataAvailable, $ptr(OnDataAvailableProc)
mov sIBindStatusCallback.OnObjectAvailable, $ptr(ObjectAvailableProc)
mov sIBindStatusCallback.AddRef, $ptr(AddReleaseProc)
mov sIBindStatusCallback.Release, $ptr(AddReleaseProc)
mov sIBindStatusCallback.OnProgress, $ptr(OnProgressProc)
mov sIBindStatusCallback.QueryInterface, $ptr(QueryInterfaceProc)
invoke URLDownloadToFile, NULL, chr$("http://x86assembly.codegurus.org/GeneSys.zip", 0), chr$("GeneSys.zip", 0), NULL, addr sIBindStatusCallback
.IF eax == INET_E_DOWNLOAD_FAILURE
	invoke MessageBox, NULL, chr$("Download Failed.", 0), NULL, MB_OK
.ENDIF
invoke ExitProcess, 0
WinMain endp
END